#include "parti.h"
/*
  wrapper for the gather function. 
*/

extern SCHED *get_sched_ptr();

/*==============================================*/
void
  PREFIXgather_(data,target,schedindex)
int *schedindex;
TYPE *data, *target;
{

  PREFIXgather(data,target,(SCHED *)get_sched_ptr(*schedindex));
}

/*==============================================*/
/*
  wrapper for the multigather function. 
*/

void
 PREFIXmultigather_(data,target,n_scheds,sarray,base_shift,dialation,repetition)
TYPE *data, *target;
int *n_scheds, *base_shift, *dialation, *repetition;
int *sarray;
{
  int i;
  SCHED **scharray;

  scharray = (SCHED **)malloc(sizeof(SCHED *)**n_scheds);
  for(i=0;i<*n_scheds;i++)
     scharray[i] = (SCHED *)get_sched_ptr(sarray[i]);
  PREFIXmultigather(data,target,*n_scheds,scharray,*base_shift,
                                      *dialation,*repetition);
  free(scharray);
}


/*==============================================*/
/* 
  wrapper for the scatter function. 
*/

void 
  PREFIXscatter_(data,target,schedindex)
int *schedindex;
TYPE *data, *target;
{

  PREFIXscatter(data,target,(SCHED *)get_sched_ptr(*schedindex));
}

/*==============================================*/
/*
  wrapper for the multiscatter function. 
*/

void
 PREFIXmultiscatter_(data,target,n_scheds,sarray,base_shift,dialation,repetition)
TYPE *data, *target;
int *n_scheds, *base_shift, *dialation, *repetition;
int *sarray;
{
  int i;
  SCHED **scharray;

  scharray = (SCHED **)malloc(sizeof(SCHED *)**n_scheds);
  for(i=0;i<*n_scheds;i++)
     scharray[i] = (SCHED *)get_sched_ptr(sarray[i]);
  PREFIXmultiscatter(data,target,*n_scheds,scharray,*base_shift,
                                      *dialation,*repetition);
  free(scharray);
}

/*==============================================*/
/*
  wrapper for the scatter_add function. 
*/

void 
  PREFIXscatter_add_(data,target,schedindex)
int *schedindex;
TYPE *data, *target;
{

  PREFIXscatter_add(data,target,(SCHED *)get_sched_ptr(*schedindex));
}


/*==============================================*/
/*
  wrapper for the multiscatter_add function. 
*/

void
 PREFIXmultiscatter_add_(data,target,n_scheds,sarray,
                                        base_shift,dialation,repetition)
TYPE *data, *target;
int *n_scheds, *base_shift, *dialation, *repetition;
int *sarray;
{
  int i;
  SCHED **scharray;

  scharray = (SCHED **)malloc(sizeof(SCHED *)**n_scheds);
  for(i=0;i<*n_scheds;i++)
     scharray[i] = (SCHED *)get_sched_ptr(sarray[i]);
  PREFIXmultiscatter_add(data,target,*n_scheds,scharray,*base_shift,
                                      *dialation,*repetition);
  free(scharray);
}


/*==============================================*/
/*
  wrapper for the scatter_sub function. 
*/

void 
  PREFIXscatter_sub_(data,target,schedindex)
int *schedindex;
TYPE *data, *target;
{

  PREFIXscatter_sub(data,target,(SCHED *)get_sched_ptr(*schedindex));
}


/*==============================================*/
/*
  wrapper for the multiscatter_sub function. 
*/

void
 PREFIXmultiscatter_sub_(data,target,n_scheds,sarray,
                                        base_shift,dialation,repetition)
TYPE *data, *target;
int *n_scheds, *base_shift, *dialation, *repetition;
int *sarray;
{
  int i;
  SCHED **scharray;

  scharray = (SCHED **)malloc(sizeof(SCHED *)**n_scheds);
  for(i=0;i<*n_scheds;i++)
     scharray[i] = (SCHED *)get_sched_ptr(sarray[i]);
  PREFIXmultiscatter_sub(data,target,*n_scheds,scharray,*base_shift,
                                      *dialation,*repetition);
  free(scharray);
}


/*==============================================*/
/*
  wrapper for the scatter_mult function. 
*/

void 
  PREFIXscatter_mult_(data,target,schedindex)
int *schedindex;
TYPE *data, *target;
{

  PREFIXscatter_mult(data,target,(SCHED *)get_sched_ptr(*schedindex));
}


/*==============================================*/
/*
  wrapper for the multiscatter_mult function. 
*/

void
 PREFIXmultiscatter_mult_(data,target,n_scheds,sarray,
                                        base_shift,dialation,repetition)
TYPE *data, *target;
int *n_scheds, *base_shift, *dialation, *repetition;
int *sarray;
{
  int i;
  SCHED **scharray;

  scharray = (SCHED **)malloc(sizeof(SCHED *)**n_scheds);
  for(i=0;i<*n_scheds;i++)
     scharray[i] = (SCHED *)get_sched_ptr(sarray[i]);
  PREFIXmultiscatter_mult(data,target,*n_scheds,scharray,*base_shift,
                                      *dialation,*repetition);
  free(scharray);
}


/*==============================================*/
/* 
  wrapper for the scatternc function. 
*/

void 
  PREFIXscatternc_(data,target,schedindex)
int *schedindex;
TYPE *data, *target;
{

  PREFIXscatternc(data,target,(SCHED *)get_sched_ptr(*schedindex));
}

/*==============================================*/
/*
  wrapper for the multiscatternc function. 
*/

void
 PREFIXmultiscatternc_(data,target,n_scheds,sarray,base_shift,dialation,repetition)
TYPE *data, *target;
int *n_scheds, *base_shift, *dialation, *repetition;
int *sarray;
{
  int i;
  SCHED **scharray;

  scharray = (SCHED **)malloc(sizeof(SCHED *)**n_scheds);
  for(i=0;i<*n_scheds;i++)
     scharray[i] = (SCHED *)get_sched_ptr(sarray[i]);
  PREFIXmultiscatternc(data,target,*n_scheds,scharray,*base_shift,
                                      *dialation,*repetition);
  free(scharray);
}

/*==============================================*/
/*


/*
  wrapper for the scatter_addnc function. 
*/

void 
  PREFIXscatter_addnc_(data,target,schedindex)
int *schedindex;
TYPE *data, *target;
{

  PREFIXscatter_addnc(data,target,(SCHED *)get_sched_ptr(*schedindex));
}


/*==============================================*/
/*
  wrapper for the multiscatter_addnc function. 
*/

void
 PREFIXmultiscatter_addnc_(data,target,n_scheds,sarray,
                                        base_shift,dialation,repetition)
TYPE *data, *target;
int *n_scheds, *base_shift, *dialation, *repetition;
int *sarray;
{
  int i;
  SCHED **scharray;

  scharray = (SCHED **)malloc(sizeof(SCHED *)**n_scheds);
  for(i=0;i<*n_scheds;i++)
     scharray[i] = (SCHED *)get_sched_ptr(sarray[i]);
  PREFIXmultiscatter_addnc(data,target,*n_scheds,scharray,*base_shift,
                                      *dialation,*repetition);
  free(scharray);
}


/*==============================================*/
/*
  wrapper for the scatter_subnc function. 
*/

void 
  PREFIXscatter_subnc_(data,target,schedindex)
int *schedindex;
TYPE *data, *target;
{

  PREFIXscatter_subnc(data,target,(SCHED *)get_sched_ptr(*schedindex));
}


/*==============================================*/
/*
  wrapper for the multiscatter_subnc function. 
*/

void
 PREFIXmultiscatter_subnc_(data,target,n_scheds,sarray,
                                        base_shift,dialation,repetition)
TYPE *data, *target;
int *n_scheds, *base_shift, *dialation, *repetition;
int *sarray;
{
  int i;
  SCHED **scharray;

  scharray = (SCHED **)malloc(sizeof(SCHED *)**n_scheds);
  for(i=0;i<*n_scheds;i++)
     scharray[i] = (SCHED *)get_sched_ptr(sarray[i]);
  PREFIXmultiscatter_subnc(data,target,*n_scheds,scharray,*base_shift,
                                      *dialation,*repetition);
  free(scharray);
}


/*==============================================*/
/*
  wrapper for the scatter_multnc function. 
*/

void 
  PREFIXscatter_multnc_(data,target,schedindex)
int *schedindex;
TYPE *data, *target;
{

  PREFIXscatter_multnc(data,target,(SCHED *)get_sched_ptr(*schedindex));
}


/*==============================================*/
/*
  wrapper for the multiscatter_multnc function. 
*/

void
 PREFIXmultiscatter_multnc_(data,target,n_scheds,sarray,
                                        base_shift,dialation,repetition)
TYPE *data, *target;
int *n_scheds, *base_shift, *dialation, *repetition;
int *sarray;
{
  int i;
  SCHED **scharray;

  scharray = (SCHED **)malloc(sizeof(SCHED *)**n_scheds);
  for(i=0;i<*n_scheds;i++)
     scharray[i] = (SCHED *)get_sched_ptr(sarray[i]);
  PREFIXmultiscatter_multnc(data,target,*n_scheds,scharray,*base_shift,
                                      *dialation,*repetition);
  free(scharray);
}
/*==============================================*/
/*==============================================*/
/* 
  wrapper for the scatter_append function. 
*/

void 
  PREFIXscatter_append_(data,target,sched)
int *sched;
TYPE *data, *target;
{

  PREFIXscatter_append(data,target,(SCHED *)get_sched_ptr(*sched));
}

